var enex = {
    _wrapErrorHandler: function(callback) {
        return function(xhr, textStatus, errorThrown) {
            var prefix = "Erreur: ";
            if (errorThrown !== null)
                callback(prefix + String(errorThrown));
            else
                callback(prefix + String(textStatus));
        };
    },
    _wrapDownloadSuccessHandler: function(callback) {
        return function(json) {
            callback(events.parseEnexEvents(json));
        };
    },
    downloadEvents: function(start, end, success_callback, failure_callback) {
        var json_url = "https://enex.polytechnique.fr/edt2/eleve/json-events.php?start=" + start.unix() + "&end=" + end.unix();

        $.ajax({
            url: json_url,
            cache: false,
            error: enex._wrapErrorHandler(failure_callback),
            success: enex._wrapDownloadSuccessHandler(success_callback),
            timeout: 10 * 1000,
            type: "GET"
        });
    },
    _wrapAuthenticationErrorHandler: function(callback) {
        return function(xhr, textStatus, errorThrown) {
            errorThrown = String(errorThrown);
            if (errorThrown !== "")
                callback(errorThrown);
            else
                callback(textStatus);
        };
    },
    _wrapAuthenticationSuccessHandler: function(callback) {
        return function(json) {
            callback(events.parseEnexEvents(json));
        };
    },
    authenticateAndDowload: function(username, password, start, end, failure_callback, success_callback) {
        var enex_url = "https://enex.polytechnique.fr/";
        var params = "login=" + encodeURIComponent(username) + "&password=" + encodeURIComponent(password) + "&Valider=%A0%A0%A0%A0Valider%A0%A0%A0%A0";

        $.ajax({
            url: enex_url,
            cache: false,
            data: params,
            error: enex._wrapErrorHandler(failure_callback),
            success: function(data) {
                var FAILURE_MSG = "Login ou mot de passe incorrect";
                if (data.indexOf(FAILURE_MSG) >= 0) {
                    failure_callback("Identifiants incorrects");
                } else {
                    enex.downloadEvents(start, end, success_callback, failure_callback);
                }
            },
            timeout: 10 * 1000,
            type: "POST"
        });
    },
    disconnect: function(callback) {
        var disconnect_url = "https://enex.polytechnique.fr/?P=DISCO";
        $.get(disconnect_url, callback);
    }
};