var slide_direction = null;

function changeView(period_type_override) {
    state.period_type = period_type_override;
    displayEvents();
}

function changeDate(delta) {
    state.reference_date.add(state.period_type, delta);
    $("#date-box").html(utils.formatDate(state.period_type, state.reference_date));
}


/*
 var records = [];
 
 function onMapClick(e) {
 var label = window.prompt("What's at " + e.latlng + "?");
 if (label !== null) {
 var point = { "location": e.latlng, "label": label };
 records.push(point);
 saveRecords();
 L.marker(point.location).addTo(map.leaflet).bindPopup(point.label);
 }
 }
 
 function saveRecords() {
 window.localStorage.setItem("gps", JSON.stringify(records));
 }
 
 function popRecord() {
 records.pop();
 saveRecords();
 $("#map").empty();
 map.show(-1);
 }
 
 function printRecords() {
 var strs = [];
 for (var id = 0; id < records.length; id++) {
 var record = records[id];
 record.etage = "RDC";
 strs.push([record.location.lat, record.location.lng, record.label].join('\t'));
 }
 console.log(strs.join('\n'));
 console.log(JSON.stringify(records, null, 3));
 }
 
 records = JSON.parse(window.localStorage.getItem("gps"));
 if (records !== null) {
 } else {
 records = [];
 }
 */

function directionMultiplier() {
    switch (slide_direction) {
        case "left":
            return 1;
        case "right":
            return -1;
        default:
            return 0;
    }
}

function getOffset(factor) {
    return directionMultiplier() * factor * window.innerWidth;
}

function setPanelsDisplay() {
    state.currentPanel().css("display", "block");
    state.hiddenPanel().css("display", "none");
}

function hidePanel(panel) {
    panel.animate({"opacity": 0}, 100, setPanelsDisplay);
    /*
     var panel = state.currentPanel();
     panel.animate({left: getOffset(1.1)}, 100, "ease", function() {
     panel.css("display", "none");
     }); // Slide out*/
}

function showPanel(panel) {
    panel.scrollTop(0).css("display", "block").animate({"opacity": 1}, 100, setPanelsDisplay);
    /*
     panel
     .css("left", getOffset(-1.1))
     .css("display", "block")
     .animate({"left": 0}, 100, "ease");*/
}

function stalk(tap_event) {
    utils.stopPropagation(tap_event);
    utils.navigateTo("http://gog.is/" + encodeURIComponent($(this).html() + ' Polytechnique').replace(/%20/g, "+"));
    return false;
}

function mail(tap_event) {
    utils.stopPropagation(tap_event);
    // Mail sent through href
    return true;
}

function poi(tap_event) {
    utils.stopPropagation(tap_event);
    map.show(Number($(this).attr("data-poi-id")));
    return false;
}

function navigationHandler(url) {
    return function(tap_event) {
        utils.stopPropagation(tap_event);
        utils.navigateTo(url);
        return false;
    };
}

function eventTapped(tap_event) {
    utils.stopPropagation(tap_event);
    
    if (utils.isVisible("#event-details-wrapper")) {
        hideDetails();
        return;
    }
    
    var id = Number($(this).attr("data-id"));
    if (!isNaN(id) && id >= 0 && id < state.all_events.length) {
        $.get('res/template-day-detailed.html', function(template) {
            var event = state.all_events[id];
            var sigle = event.sigle;
            
            var block = $("#event-details");
            block.html(Mustache.render(template, event));
            block.find(".stalk").click(stalk);
            block.find(".mail").click(mail);
            block.find(".poi").click(poi);
            block.find("#catalogue-button").click(navigationHandler('https://catalogue.polytechnique.fr/cours.php?code=EP_' + sigle));
            block.find("#wikix-button").click(navigationHandler('https://wikix.polytechnique.org/' + sigle));
            $("#event-details-wrapper").css("display", "table").animate({"opacity": 1}, 100);
            regBackKey();
        });
    }
}

function hideDetails() {
    utils.hideElement("#event-details-wrapper");
    map.hide(); //TODO: If map still has flickering marker problems, hide markers here.
    return false;
}

function displayEvents() {
    changeDate(0);

    var period = state.reference_date.clone().startOf(state.period_type);
    var filtered_events = utils.filter(state.all_events, function(event) {
        return event.debut.clone().startOf(state.period_type).diff(period) === 0;
    });

    hideDetails();

    var panel = state.currentPanel();
    panel.empty();

    if (filtered_events.length > 0) {
        $.get('res/template-' + state.period_type + '.html', function(template) {
            panel.html(Mustache.render(template, filtered_events));
            $(panel).find(".event").click(eventTapped);
            showPanel(panel);
        });
    } else {
        $("#no-events-root").clone().removeAttr("id").appendTo(panel);
        showPanel(panel);
        toggleReloadButton(true);
    }
}

function connectionFailure(message) {
    $("#error-message").html(message);
    $("#loading-message").css("display", "none");
    $("#error-message").css("display", "block");
    $("#messages").css("visibility", "visible");
}

function eventsReceived(events) {
    if (events.length > 0) {
        state.all_events = events;
        state.save();
    }

    switchUI(true);
    displayEvents();
}

function toggleReloadButton(enabled) {
    if (enabled)
        $(".reload-button").removeAttr("disabled");
    else
        $(".reload-button").attr("disabled", true);
    $(".reload-title").css("display", enabled ? "block" : "none");
    $(".reload-loading").css("display", enabled ? "none" : "block");
}

function reloadButton_click() {
    toggleReloadButton(false);
    reloadEvents();
}

function reloadEvents() {
    slide_direction = null;
    var dates = utils.dateRange(state.reference_date);
    enex.authenticateAndDowload(state.username, state.password, dates.start, dates.end, connectionFailure, eventsReceived);
}

function displayEventsWithAnimation(direction) {
    slide_direction = direction;
    hidePanel(state.currentPanel());
    state.events_panel_id = (state.events_panel_id + 1) % 2;
    displayEvents();
}

function connect() {
    state.username = $("#username").val();
    state.password = $("#password").val();

    $("#error-message").css("display", "none");
    $("#loading-message").css("display", "block");
    $("#messages").css("visibility", "visible");

    reloadEvents();
    return false;
}

function disconnect() {
    state = new State();
    state.save();

    enex.disconnect();
    switchUI(false);
    return false;
}

function toggleUIElements(logged_in, show) {
    if (!logged_in || (logged_in !== show)) {
        $("#connection-panel").css("display", logged_in ? "none" : "table");
    }

    if (logged_in || (logged_in === show)) {
        var block = logged_in ? "block" : "none";
        $("#events-panel").css("display", block);
        $("#navigation").css("display", block);
        $("#disconnection-button").css("display", block);
        $("#date-box").css("display", block);
    }

    $("#messages").css("visibility", "hidden");
}

function switchUI(logged_in) {
    var fade_out = logged_in ? ".disconnected" : ".connected";
    var fade_in = logged_in ? ".connected" : ".disconnected";

    toggleUIElements(logged_in, true);

    if (!logged_in)
        hideDetails();

    $(fade_out).each(utils.fadeOut);
    $(fade_in).each(utils.fadeIn);

    window.setTimeout(function() {
        toggleUIElements(logged_in, false);
    }, 100);
}

function moveForwards() {
    changeDate(1);
    displayEventsWithAnimation('right');
    return false;
}

function moveBackwards() {
    changeDate(-1);
    displayEventsWithAnimation('left');
    return false;
}

function regBackKey() {
    document.addEventListener("backbutton", onBackKeyDown, false);
}

function tryUnregBackKey() {
    if (!PressBackKey(false))
        document.removeEventListener("backbutton", onBackKeyDown, false);
}

function PressBackKey(realPress) {
    var action = null;
    
    if (map.isSearchVisible()) {
        action = map.hideSearch;
    } else if (utils.isVisible("#map-panel")) {
        action = map.hide;
    } else if (utils.isVisible("#event-details-wrapper")) {
        action = hideDetails;
    } else {
        return false;
    }
 
    if (realPress)
        action();
    
    return true;
}

function onBackKeyDown(e) {
    PressBackKey(true);
    tryUnregBackKey();
}

function init() {
    //$(document).on('ajaxBeforeSend', function(e, xhr) {
    //    xhr.open = utils.xhrOpenOverride(xhr);
    //});

    //$.ajaxSettings.xhr = function() {
    //    return new XHRWrapper();
    //}

    $("#navigation-day").click(function() {
        changeView('day');
        return false;
    });

    $("#navigation-week").click(function() {
        changeView('week');
        return false;
    });
    
    $("#map-button").click(function() {
        map.show();
        return false;
    });

    $("#map-close").click(function() {
        map.hide();
        return false;
    });

    $("#map-search").click(function() {
        map.toggleSearch();
        return false;
    });

    $("#navigation-prev").click(moveBackwards);
    $("#navigation-next").click(moveForwards);

    $("#connection-button").click(connect);
    $("#disconnection-button").click(disconnect);

    $("#events-panel").swipeRight(moveBackwards);
    $("#events-panel").swipeLeft(moveForwards);
    $("#events-panel").click(hideDetails);
}