var storage = {
    _file_entry: undefined,
    
    _logFailure: function(message) {
        return function(err) {
            console.log("Storage failure: " + message + "(" + err.code + ")");
        };
    },
    
    _gotFileEntry: function(file_entry) {
        storage._file_entry = file_entry;
    },
    
    _gotFileSystem: function(file_system) {
        file_system.root.getFile('eventsDB', {create: true, exclusive: false}, storage._gotFileEntry, storage._logFailure("getFile"));
    },
    
    init: function() {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, storage._gotFileSystem, storage._logFailure("requestFileSystem"));
    },
    
    _gotFile: function(callback) {
        return function(file) {
            var reader = new FileReader();
            reader.onloadend = function(evt) { callback(evt.target.result); };
            reader.readAsText(file);
        };
    },
    
    read: function(callback) {
        storage._file_entry.file(storage._gotFile(callback), storage._logFailure("read"));
    },
    
    _gotWriter: function(text) {
        return function(writer) { writer.write(text); };
    },
    
    write: function(text) {
        storage._file_entry.createWriter(storage._gotFileWriter(text), storage._logFailure("write"));
    }
};